* Sorts a Browse in any field order
* Author - David Rozas 75277,1000
* Last Updated - 12/08/94
* SORT BROWSE Copyright 1994 David Rozas
* PARAMETERS:	<dbfName> = file name to be sorted
*				<cTitle> = the Browse title (optional - if other than file name) 
* NOTE1:	This utility reads the application resource file:
*			do not SET RESOURCE OFF!
* NOTE2:	Each of your applications should have its own resource file
* NOTE3:	the browse to be sorted must exist prior to SortBrowse call
* EXAMPLE CALLS:
*	DO SortBrowse WITH "Customer"
*	DO SortBrowse WITH "Customer","ACME Costumers"
* Some testing has been done with Foxpro 2.6 for Windows and Foxpro 2.5 for DOS
* There is no guarantee SortBrowse will work with future Foxpro versions

*-------------------
PROCEDURE SortBrowse
PARAMETERS dbfName, cTitle

PRIVATE header, indexExpr, l, n, i, temp, idxName, aTable
SET TALK OFF
IF !USED(dbfName)
	WAIT WINDOW 'Table '+dbfName+'.dbf not used.'
	RETURN
ENDIF
IF PARAMETERS() < 2
	PRIVATE cTitle
	cTitle = dbfName
ENDIF
IF !WEXIST(cTitle)
	WAIT WINDOW 'Browse window "'+cTitle+'" does not exist.'
	RETURN
ENDIF
indexExpr = ''
idxName = RandomString(8)				&& you may choose something else here
RELEASE WINDOW (cTitle)
= BrowseInfo(cTitle, dbfName)

SELECT (dbfName)
= AFIELDS(aTable)
l = 0
FOR i=1 TO ALEN(aFlds,1)				&& set n-fields to print
	l = l + aFlds[i,3] + 1				&& browse width
	IF l > 80
		EXIT
	ENDIF
NEXT
n = i - 1								&& number of columns to index on

FOR i=1 TO n
	header = TRIM(aFlds[i,2])			&& column header
	temp = Expr2c(TRIM(aFlds[i,1]))		&& column field name
	IF !EMPTY(temp)
		indexExpr = indexExpr + temp + '+'
	ENDIF
NEXT

indexExpr = SUBSTR(indexExpr,1,LEN(indexExpr)-1)

DO CASE
CASE TYPE('indexExpr') != 'C'
	WAIT WINDOW 'Failed to build index expression. Abandoning Sort...'
CASE EMPTY(indexExpr)
	WAIT WINDOW 'Sort expression empty. Abandoning Sort...'
OTHERWISE
	SET SAFETY OFF
	SET NOTIFY ON
	SET TALK ON
	SET TALK WINDOW

	INDEX ON &indexExpr TO (idxName) COMPACT

	SET INDEX TO (idxName)			&& you may want to delete this .IDX at some point!
	SET TALK OFF
	SET SAFETY ON
	WAIT WINDOW "Sort Completed!" NOWAIT
ENDCASE

release aFlds, repHeader
ACTIVATE SCREEN
BROWSE LAST NOWAIT
RETURN


*------------------	
FUNCTION BrowseInfo
PARAM cTitle, cName

PRIVATE flds, x, n, z, p1, p2, p3, p4, m, d, foxUserFile
SET RESOURCE OFF
SET TALK OFF
foxUserFile = SYS(2005)
USE (foxUserFile) IN 0 ALIAS foxuser
SELECT foxuser
IF _DOS
	LOCATE FOR Type = 'PREF2.5' AND Id = 'WINDBROW' AND ;
		Name = UPPER(cName) AND LEN(TRIM(Name)) = LEN(cName)
	d = 83
ELSE
	LOCATE FOR Type = 'PREFW' AND Id = 'WINDBROW' AND ;
		Name = UPPER(cName) AND LEN(TRIM(Name)) = LEN(cName)
	d = 217
ENDIF
IF !FOUND()
	WAIT WINDOW 'Programming problem: '+cName+' Browse Info not found in '+foxUserFile
	CANCEL
ENDIF

IF UPDATED != DATE()
	WAIT WINDOW 'Programming problem: '+cName+' Browse Info old in '+foxUserFile
	CANCEL
ENDIF

cData = Data
USE
SET RESOURCE ON

n = ASC(SUBSTR(cData,7,1))
m = d + 63*n

PUBLIC ARRAY aFlds[n,3]
DIMENSION af(n)
PUBLIC repHeader
repHeader = ''

FOR i=1 TO n
	x15 = ASC(SUBSTR(cData,d+(i-1)*63+15,1))
	x14 = ASC(SUBSTR(cData,d+(i-1)*63+14,1))
	x13 = ASC(SUBSTR(cData,d+(i-1)*63+13,1))*256
	x12 = ASC(SUBSTR(cData,d+(i-1)*63+12,1))
	x = x13 + x12 - IIF(x15 = 0, x14, 0)
	af[i] = x
NEXT

z = ''
FOR i=1 TO n
	z = SUBSTR(cData,af[i]+m,IIF(i<n, af[i+1], LEN(cData)+1)-af[i])
	p1 = AT(CHR(00),z,1)
	p2 = AT(CHR(00),z,2)
	p3 = RAT(CHR(00),z,2)
	p4 = RAT(CHR(00),z,1)
	sw = ASC(SUBSTR(cData,d+(i-1)*63+4,1))
	aFlds[i,1] = SUBSTR(z,p1+1,p2-p1-1)
	aFlds[i,2] = SUBSTR(z,p3+1,p4-p3-2)
	aFlds[i,3] = sw
	repHeader = repHeader + PADC(aFlds[i,2],aFlds[i,3]+2)
NEXT
RETURN


*--------------
FUNCTION Expr2c
PARAM x
PRIVATE flen,fdec,pos

DO CASE
CASE TYPE(x) = 'C'
	RETURN x
CASE TYPE(x) = 'D'
	RETURN 'dtos('+x+')'
CASE TYPE(x) = 'N'
	pos = asubscript[aTable,ASCAN(aTable,UPPER(x)),1]
	flen = LTRIM(STR(aTable[pos,3]))
	fdec = LTRIM(STR(aTable[pos,4]))
	RETURN 'str('+x+','+flen+','+fdec+')'
CASE TYPE(x) = 'L'
	RETURN 'iif('+x+',"1","0")'
OTHERWISE
	RETURN ''
ENDCASE


*--------------------		return random n-digit number as a string
FUNCTION RandomString
PARAM n

x = 10^n
y = INT(x)*RAND()
RETURN SUBSTR(STR(y,n+1),2)

